scala.collection.generic

# GenericParTemplate

###
Related Doc: package generic

#### trait GenericParTemplate[+A, +CC[X] <: ParIterable[X]] extends GenericTraversableTemplate[A, CC] with HasNewCombiner[A, CC[A]]

A template trait for collections having a companion.

A

  the element type of the collection

CC

  the type constructor representing the collection class

Source
  GenericParTemplate.scala
Since

  2.8

Linear Supertypes
HasNewCombiner[A, CC[A] @scala.annotation.unchecked.uncheckedVariance], GenericTraversableTemplate[A, CC], HasNewBuilder[A, CC[A] @scala.annotation.unchecked.uncheckedVariance], AnyRef, Any
Known Subclasses
DefaultKeySet, DefaultValuesIterable, GenericParMapTemplate, ParArray, ParHashMap, ParHashMap, ParHashSet, ParHashSet, ParIterable, ParIterable, ParIterable, ParMap, ParMap, ParMap, ParRange, ParSeq, ParSeq, ParSeq, ParSet, ParSet, ParSet, ParTrieMap, ParVector, WithDefault, WithDefault, WithDefault
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. GenericParTemplate
2. HasNewCombiner
3. GenericTraversableTemplate
4. HasNewBuilder
5. AnyRef
6. Any

Implicitly

1. by CollectionsHaveToParArray
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def companion: GenericCompanion[CC] with GenericParCompanion[CC]

   The factory companion object that builds instances of class Traversable.

   The factory companion object that builds instances of class Traversable. (or its `Iterable` superclass where class Traversable is not a `Seq`.)

   Definition Classes
     GenericParTemplate → GenericTraversableTemplate

2. #### abstract def head: A

   Selects the first element of this collection.

   Selects the first element of this collection.

   returns

     the first element of this collection.

   Definition Classes
     GenericTraversableTemplate
   Exceptions thrown

     `NoSuchElementException` if the collection is empty.

3. #### abstract def isEmpty: Boolean

   Tests whether this collection is empty.

   Tests whether this collection is empty.

   returns

     `true` if the collection contain no elements, `false` otherwise.

   Definition Classes
     GenericTraversableTemplate

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from GenericParTemplate[A, CC] to any2stringadd[GenericParTemplate[A, CC]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (GenericParTemplate[A, CC], B)

   Implicit information
     This member is added by an implicit conversion from GenericParTemplate[A, CC] to ArrowAssoc[GenericParTemplate[A, CC]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (GenericParTemplate[A, CC]) ⇒ Boolean, msg: ⇒ Any): GenericParTemplate[A, CC]

   Implicit information
     This member is added by an implicit conversion from GenericParTemplate[A, CC] to Ensuring[GenericParTemplate[A, CC]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (GenericParTemplate[A, CC]) ⇒ Boolean): GenericParTemplate[A, CC]

   Implicit information
     This member is added by an implicit conversion from GenericParTemplate[A, CC] to Ensuring[GenericParTemplate[A, CC]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): GenericParTemplate[A, CC]

    Implicit information
      This member is added by an implicit conversion from GenericParTemplate[A, CC] to Ensuring[GenericParTemplate[A, CC]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): GenericParTemplate[A, CC]

    Implicit information
      This member is added by an implicit conversion from GenericParTemplate[A, CC] to Ensuring[GenericParTemplate[A, CC]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

15. #### def flatten[B]: Traversable[B]

    [use case] Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    [use case]

    Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of collection. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(1, 2, 3)
                 ).flatten
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(
                   List(1, 2, 3),
                   List(3, 2, 1)
                 ).flatten
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new collection resulting from concatenating all element collections.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): CC[B]

16. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case]

    [use case]
    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### abstract def foreach[U](f: (A) ⇒ U): Unit

17. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from GenericParTemplate[A, CC] to StringFormat[GenericParTemplate[A, CC]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### def genericBuilder[B]: Combiner[B, CC[B]]

    The generic builder that builds instances of Traversable at arbitrary element types.

    The generic builder that builds instances of Traversable at arbitrary element types.

    Definition Classes
      GenericParTemplate → GenericTraversableTemplate

19. #### def genericCombiner[B]: Combiner[B, CC[B]]

20. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

22. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

23. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

24. #### def newBuilder: Builder[A, CC[A]]

    The builder that builds instances of type Traversable[A]

    The builder that builds instances of type Traversable[A]

    Attributes
      protected[this]
    Definition Classes
      GenericParTemplate → GenericTraversableTemplate → HasNewBuilder

25. #### def newCombiner: Combiner[A, CC[A]]

    Attributes
      protected[this]
    Definition Classes
      GenericParTemplate → HasNewCombiner

26. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

27. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

28. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

29. #### def toParArray: ParArray[T]

    Implicit information
      This member is added by an implicit conversion from GenericParTemplate[A, CC] to CollectionsHaveToParArray[GenericParTemplate[A, CC], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (GenericParTemplate[A, CC]) ⇒ GenTraversableOnce[T] is in scope.
    Definition Classes
      CollectionsHaveToParArray

30. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

31. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): CC[CC[B]]

    Transposes this collection of traversable collections into a collection of collections.

    Transposes this collection of traversable collections into a collection of collections.

    The resulting collection's type will be guided by the static type of collection. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(4, 5, 6)).transpose
        // xs == List(
        //         List(1, 4),
        //         List(2, 5),
        //         List(3, 6))

        val ys = Vector(
                   List(1, 2, 3),
                   List(4, 5, 6)).transpose
        // ys == Vector(
        //         Vector(1, 4),
        //         Vector(2, 5),
        //         Vector(3, 6))

    B

      the type of the elements of each traversable collection.

    asTraversable

      an implicit conversion which asserts that the element type of this collection is a `Traversable`.

    returns

      a two-dimensional collection of collections which has as nth row the nth column of this collection.

    Definition Classes
      GenericTraversableTemplate
    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

    Exceptions thrown

      `IllegalArgumentException` if all collections in this collection are not of the same size.

32. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (CC[A1], CC[A2])

    Converts this collection of pairs into two collections of the first and second half of each pair.

    Converts this collection of pairs into two collections of the first and second half of each pair.

        val xs = Traversable(
                   (1, "one"),
                   (2, "two"),
                   (3, "three")).unzip
        // xs == (Traversable(1, 2, 3),
        //        Traversable(one, two, three))

    A1

      the type of the first half of the element pairs

    A2

      the type of the second half of the element pairs

    asPair

      an implicit conversion which asserts that the element type of this collection is a pair.

    returns

      a pair of collections, containing the first, respectively second half of each element pair of this collection.

    Definition Classes
      GenericTraversableTemplate

33. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (CC[A1], CC[A2], CC[A3])

    Converts this collection of triples into three collections of the first, second, and third element of each triple.

    Converts this collection of triples into three collections of the first, second, and third element of each triple.

        val xs = Traversable(
                   (1, "one", '1'),
                   (2, "two", '2'),
                   (3, "three", '3')).unzip3
        // xs == (Traversable(1, 2, 3),
        //        Traversable(one, two, three),
        //        Traversable(1, 2, 3))

    A1

      the type of the first member of the element triples

    A2

      the type of the second member of the element triples

    A3

      the type of the third member of the element triples

    asTriple

      an implicit conversion which asserts that the element type of this collection is a triple.

    returns

      a triple of collections, containing the first, second, respectively third member of each element triple of this collection.

    Definition Classes
      GenericTraversableTemplate

34. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### def →[B](y: B): (GenericParTemplate[A, CC], B)

    Implicit information
      This member is added by an implicit conversion from GenericParTemplate[A, CC] to ArrowAssoc[GenericParTemplate[A, CC]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from HasNewCombiner[A, CC[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from GenericTraversableTemplate[A, CC]

### Inherited from HasNewBuilder[A, CC[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from GenericParTemplate[A, CC] to CollectionsHaveToParArray[GenericParTemplate[A, CC], T]

### Inherited by implicit conversion any2stringadd from GenericParTemplate[A, CC] to any2stringadd[GenericParTemplate[A, CC]]

### Inherited by implicit conversion StringFormat from GenericParTemplate[A, CC] to StringFormat[GenericParTemplate[A, CC]]

### Inherited by implicit conversion Ensuring from GenericParTemplate[A, CC] to Ensuring[GenericParTemplate[A, CC]]

### Inherited by implicit conversion ArrowAssoc from GenericParTemplate[A, CC] to ArrowAssoc[GenericParTemplate[A, CC]]

### Ungrouped